
#include "legobase.inc"
#include "techbase.inc"
//#include "flat.inc"
//#include "bricksXxXx1.inc"
//#include "bricksXxXx3.inc"
//#include "tbricksXx1x3.inc"
//#include "tbricksXx1x1.inc"
#include "axles.inc"
//#include "rivets.inc"
#include "bush.inc"
#include "gear.inc"

#include "motor_cylinder.inc"

light_source {<-100, 100, -100>*l color White }
light_source {<-50, 100, -100>*l color White }
light_source {<50, 1000, 0>*l color White*0.7 }
//light_source {<100, 100, 100>*l color White shadowless  }
//light_source {<-100, 100, 100>*l color White shadowless  }
background { White }

#declare CSize = 1/5;
camera {
    location <9*l, 40*l, -40*l>
    right <1, 0, 0> * CSize
    up    <0, 1, 0> * CSize
    direction <0, 0, 1>
    look_at <0, 0,4*l>
}




#macro Pleuel(Alpha, Omega, Radius) 

#local   Length   = 4*LEGO_LENGTH;
#local   Psi      = Omega-Alpha;
#local   cosPsi   = cos(Psi*pi/180);
#local   __X      = Radius*cosPsi + sqrt( Radius*Radius*(cosPsi*cosPsi - 1) + Length*Length);
#local   epsilon  = asin(Radius/Length*sin(Psi*pi/180))*180/pi;
 

union {
  object {
    MotorCylinder
    translate <-LEGO_LENGTH, -LEGO_KNOB_RADIUS, -LEGO_LENGTH>
  }
  union {
    object {
      HeadBush
      translate -x*l*1.5
    }
    object {
      CrossAxle3
      translate -x*l*3.5
    }
    object {
      HeadBush
      rotate x*90
      rotate y*180
      translate -x*l*2.5
    }
    rotate z*(90+epsilon)
  }
  translate <0, __X, LEGO_LENGTH/2>
  rotate -z*Alpha  
}
#end



#local Omega = clock*360 + 90;

union {
  union {
    object { 
      CrossAxle5
      rotate -y*90
      translate -z*4*l
    }
    object {
      CrossAxle4
      rotate x*45
      rotate -y*90
      translate y*1.5/2*l
    }
    object {
      CrossAxle4
      rotate x*45
      rotate -y*90
      translate <0,-1.5/2*l,3*l>
    }
    object { 
      CrossAxle5
      rotate -y*90
      translate z*6*l
    }
    object {
      Gear24
      rotate -y*90
    }
    object {
      Gear24
      rotate -y*90
      translate z*3*l
    }
    object {
      Gear24
      rotate -y*90
      translate z*6*l
    }
    rotate -z*Omega
  }
  
  object {
    Pleuel(45, Omega, 1.5/2*LEGO_LENGTH)
    translate z*LEGO_LENGTH*2
  }
  object {  
    Pleuel(-45, Omega, 1.5/2*LEGO_LENGTH)
    translate z*LEGO_LENGTH
  }
  object {
    Pleuel(45, Omega+180, 1.5/2*LEGO_LENGTH)
    translate z*LEGO_LENGTH*5
  }
  object {  
    Pleuel(-45, Omega+180, 1.5/2*LEGO_LENGTH)
    translate z*LEGO_LENGTH*4
  }
}


