global_settings {
    ambient_light   <1.0, 1.0, 1.0>
}

#include "colors.inc"
#include "legobase.inc"
#include "techbase.inc"


#include "universal-joint.inc"
#include "axles.inc"

light_source {<-10, 100, -20> color White}
light_source {<100, 100, -20> color White}
light_source {<-10, -30, -20> color White}
light_source {<100, -30, -20> color White}
background { color White }
camera {
    location <10*l, 30*l, -200>/1.09
    right <2, 0, 0>
    up    <0, 1, 0>
    direction <0, 0, 1> * 7
    look_at <2*l,  3*l, 0>
}



union {
  #local decl = 60;
  #local rot1 = clock*360+40;
  #local rot2 = UniversalJoint_Axis2Rot (rot1, decl);
  #local rot3 = rot2 + 90;
  #local rot4 = UniversalJoint_Axis2Rot (rot3, -decl);

  object {    
    CrossAxle2
    translate -x*l*3
    rotate x*rot1
  }

  object {    
    UniversalJoint(rot1, decl)  
  }

  union {
    object {    
      CrossAxle3
      translate -x*l*4
      rotate x*rot2
    }
  
    object {
      UniversalJoint(rot3, -decl)
    }
    
    object {
      CrossAxle2
      translate x*l
      rotate x*rot4
      rotate -z*decl
    }

    translate x*l*5
    rotate z*decl    
  }
  
  rotate x*20
//  rotate -y*90
}
  
