/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifndef (GENERICAXLE_INC)

    #declare GENERICAXLE_INC = 1;

#macro GenericAxle (Length, Texture)

intersection {
    difference {
        union {
            box { <-EXTRA, -LEGO_KNOB_RADIUS, -LEGO_CROSSAXLE_WIDTH/2> <Length*LEGO_LENGTH+EXTRA, LEGO_KNOB_RADIUS, LEGO_CROSSAXLE_WIDTH/2> }
            box { <-EXTRA, -LEGO_CROSSAXLE_WIDTH/2, -LEGO_KNOB_RADIUS> <Length*LEGO_LENGTH+EXTRA, LEGO_CROSSAXLE_WIDTH/2, LEGO_KNOB_RADIUS> }
            box {(-(y+z)*(LEGO_CROSSAXLE_WIDTH/2 + LEGO_KNOB_CORNER_SPACE))
                 (x*Length*LEGO_LENGTH+(y+z)*(LEGO_CROSSAXLE_WIDTH/2 + LEGO_KNOB_CORNER_SPACE))
                }
        }
        #local i = 0;
        #while (i < 4)
            cylinder { (-(y+z)*(LEGO_CROSSAXLE_WIDTH/2 + LEGO_KNOB_CORNER_SPACE) - x)
                       (x*(Length*LEGO_LENGTH + 1)-(y+z)*(LEGO_CROSSAXLE_WIDTH/2 + LEGO_KNOB_CORNER_SPACE))
                        LEGO_KNOB_CORNER_SPACE
                        rotate x*90*i
                     }
            #local i = i+1;
        #end
    }
    union {
        cylinder { <0, 0, 0> <Length*LEGO_LENGTH, 0, 0> LEGO_KNOB_RADIUS - 2*LEGO_KNOB_CORNER_SPACE}
        cylinder { <LEGO_KNOB_CORNER_SPACE*2, 0, 0> <Length*LEGO_LENGTH - 2*LEGO_KNOB_CORNER_SPACE, 0, 0> LEGO_KNOB_RADIUS }
        torus {
            LEGO_KNOB_RADIUS - LEGO_KNOB_CORNER_SPACE*2
            LEGO_KNOB_CORNER_SPACE*2
            rotate z * 90
            translate x* LEGO_KNOB_CORNER_SPACE*2
        }
        torus {
            LEGO_KNOB_RADIUS - LEGO_KNOB_CORNER_SPACE*2
            LEGO_KNOB_CORNER_SPACE*2
            rotate z * 90
            translate x*(Length*LEGO_LENGTH - LEGO_KNOB_CORNER_SPACE*2)
        }
    }
    texture { Texture }
    scale 1-EXTRA

    bounded_by { box {(-(y+z)*(LEGO_KNOB_RADIUS))
                      ( (y+z)*(LEGO_KNOB_RADIUS) + x*Length*LEGO_LENGTH) } }
}


#end
#end
