/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/


#ifndef (GENERICBRICK1_INC)

  #declare GENERICBRICK1_INC = 1;

  #include "GenericFlat.inc"

  #macro  GenericBrick1 (Length, Width)

  difference {
    union {
      GenericFlat (Length, Width)

      #if (Length*Width>1)
	union {
      #end

	  #local i = 0;
	  #while (i < Length)
	    #local j = 0;
	    #while (j < Width)
	      object { KNOB translate <i*LEGO_LENGTH, LEGO_HEIGHT, j*LEGO_LENGTH> }
	      #local j = j + 1;
	    #end
	    #local i = i + 1;
	  #end
	  
	  #if (Length*Width>1)
	    bounded_by { box {
	      <0, LEGO_HEIGHT, 0>
	      <LEGO_LENGTH*Length, LEGO_HEIGHT+LEGO_KNOB_HEIGHT, LEGO_LENGTH*Width>
	    }}
	}
	  #end
    }
    #if (Length*Width>1)
      union {
    #end
	
	#local  i = 0;
	#while (i < Length)
	  #local j = 0;
	  #while (j < Width)
	    object { INV_INNER_KNOB translate <i*LEGO_LENGTH, LEGO_HEIGHT, j*LEGO_LENGTH> }
	    #local j = j + 1;
	  #end
	  #local i = i + 1;
	#end

	#if (Length*Width>1)
	  bounded_by { box {
	    <0, LEGO_HEIGHT-LEGO_CEILING_HEIGHT, 0>
	    <LEGO_LENGTH*Length, LEGO_HEIGHT-LEGO_CEILING_HEIGHT+LEGO_INV_KNOB_HEIGHT, LEGO_LENGTH*Width>
	  }}
      }
	#end
    bounded_by { box { <0, 0, 0> <Length*LEGO_LENGTH, 2*LEGO_HEIGHT+LEGO_KNOB_HEIGHT, Width*LEGO_LENGTH> } }
}




#end

#end
