/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/


#ifndef (GENERICBRICK3_INC)


  #declare GENERICBRICK3_INC = 1;
  #include "roundbox.inc"
  #include "invroundbox.inc"


  #macro GenericBrick3(Length, Width)


  difference {
    union {
      difference {
	roundbox (Length * LEGO_LENGTH, 3*LEGO_HEIGHT, Width*LEGO_LENGTH)

	object { h_invroundbox(3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT, Length*LEGO_LENGTH-2*LEGO_WALL_WIDTH, Width*LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	  rotate z*90
	  translate <Length*LEGO_LENGTH-LEGO_WALL_WIDTH, -EXTRA, LEGO_WALL_WIDTH>
	}
      }

      #if (Width = 2)

	#local i = 1;
	#while (i < Length)
	  #local j = 1;
	  #while (j < Width)
	    object { CYLINDER3 translate <i, 0, j> * LEGO_LENGTH }
	    #local j=j+1;
	  #end
	  #local i=i+1;
	#end

	#if (Length > 5)
	  #local i = 2;
	  #while (i < Length)
	    box { <LEGO_LENGTH*i-LEGO_CYLINDER_WALL_WIDTH/2, LEGO_KNOB_HEIGHT, LEGO_WALL_WIDTH-EXTRA>
	      <LEGO_LENGTH*i+LEGO_CYLINDER_WALL_WIDTH/2, 3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH-LEGO_CYLINDER_RADIUS+LEGO_CYLINDER_WALL_WIDTH/2>
	    }
	    box { <LEGO_LENGTH*i-LEGO_CYLINDER_WALL_WIDTH/2, LEGO_KNOB_HEIGHT, 2*LEGO_LENGTH - (LEGO_WALL_WIDTH-EXTRA)>
	      <LEGO_LENGTH*i+LEGO_CYLINDER_WALL_WIDTH/2, 3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT, 2*LEGO_LENGTH-(LEGO_LENGTH-LEGO_CYLINDER_RADIUS+LEGO_CYLINDER_WALL_WIDTH/2)>
	    }
	    #local i = i + 2;
	  #end
	#end

      #else #if (Width = 1)

	#local i = 1;
	#while (i < Length)
	  object { SCYLINDER3 translate x*i*LEGO_LENGTH }
	  #local i = i+1;
	#end

      #else #if (Width > 2)

	#local i = 1;
	#while (i < Length)
	  #local j = 1+mod(i+1,2);
	  #while (j < Width)
	    object { CYLINDER3 translate <i, 0, j> * LEGO_LENGTH}
	    #local j=j+2;
	  #end
	  #local i=i+1;
	#end
	
	#local i = 1;
	#while (i < Length)
	  #local j = 1;
	  #while (j < Width)
	    #if ((mod(i,2) = 0)  & (mod (j,2) = 1))
	      box {
		#if (j = 1)
		  #local ____start = LEGO_WALL_WIDTH - EXTRA;
		#else
		  #local ____start = LEGO_LENGTH * (j-1) + LEGO_CYLINDER_RADIUS - LEGO_CYLINDER_WALL_WIDTH/2;
		#end
		
		#if (j = Width-1)
		  #local ____end = LEGO_LENGTH * Width - LEGO_WALL_WIDTH + EXTRA;
		#else
		  #local ____end = LEGO_LENGTH * (j+1) - LEGO_CYLINDER_RADIUS + LEGO_CYLINDER_WALL_WIDTH/2;
		#end
		
		<LEGO_LENGTH * i - LEGO_CYLINDER_WALL_WIDTH / 2, 0, ____start>
		<LEGO_LENGTH * i + LEGO_CYLINDER_WALL_WIDTH / 2, 3*LEGO_HEIGHT-EXTRA, ____end>
	      }
	    #else #if ((mod(i,2)=1) & (mod(j,2) = 0))
	      box {
		#if (i = 1)
		  #local ____start = LEGO_WALL_WIDTH - EXTRA;
		#else
		  #local ____start = LEGO_LENGTH * (i-1) + LEGO_CYLINDER_RADIUS - LEGO_CYLINDER_WALL_WIDTH/2;
		#end
		
		#if (i = Length-1)
		  #local ____end = LEGO_LENGTH * Length - LEGO_WALL_WIDTH + EXTRA;
		#else
		  #local ____end = LEGO_LENGTH * (i+1) - LEGO_CYLINDER_RADIUS + LEGO_CYLINDER_WALL_WIDTH/2;
		#end
		
		<____start, 0, LEGO_LENGTH * j - LEGO_CYLINDER_WALL_WIDTH / 2>
		<____end, 3*LEGO_HEIGHT-EXTRA, LEGO_LENGTH * j + LEGO_CYLINDER_WALL_WIDTH / 2>
	      }
	    #end
	    #end
	    #local j=j+1;
	  #end
	  #local i=i+1;
	#end

      #end
      #end
      #end
      
      #if (i > 1)
	union {
      #end
	  #local i = 0;
	  #while (i < Length)
	    #local j = 0;
	    #while (j < Width)
	      object { KNOB translate <i*LEGO_LENGTH, 3*LEGO_HEIGHT, j*LEGO_LENGTH> }
	      #local j=j+1;
	    #end
	    #local i=i+1;
	  #end
	  
	  #if (i>1)
	    bounded_by { box {
	      <0, LEGO_HEIGHT*3, 0>
	      <LEGO_LENGTH*Length, LEGO_HEIGHT*3+LEGO_KNOB_HEIGHT, LEGO_LENGTH*Width>
	    }}
	}
	  #end
    }

    #if (i>1)
    union {
    #end
        #local i = 0;
        #while (i < Length)
            #local j = 0;
            #while (j < Width)
                object { INV_INNER_KNOB translate <i*LEGO_LENGTH, 3*LEGO_HEIGHT, j*LEGO_LENGTH> }
                #local j=j+1;
            #end
            #local i=i+1;
        #end

    #if (i>1)
        bounded_by { box {
            <0, 3*LEGO_HEIGHT - LEGO_CEILING_HEIGHT - EXTRA, 0>
            <LEGO_LENGTH*Length, 3 * LEGO_HEIGHT + LEGO_INV_KNOB_HEIGHT - LEGO_CEILING_HEIGHT+EXTRA, LEGO_LENGTH*Width>
        }}
    }
    #end


    bounded_by {
        box {
            <0, 0, 0>
            <LEGO_LENGTH*Length, 4*LEGO_HEIGHT, LEGO_LENGTH*Width>
        }
    }
}

#end
#end
