/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef(GENERICFLAT_INC)
#else

  #declare GENERICFLAT_INC = 1;


  #include "roundbox.inc"
  #include "invroundbox.inc"

  #macro  GenericFlat (Length, Width)
  
  #if (Length > 1)
    union {
  #else
      object {
  #end
	difference {
	  roundbox(Length*LEGO_LENGTH, 1*LEGO_HEIGHT, Width*LEGO_LENGTH)
	  object { h_invroundbox(LEGO_HEIGHT-LEGO_CEILING_HEIGHT, Length*LEGO_LENGTH-2*LEGO_WALL_WIDTH, Width*LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	    rotate z*90
	    translate <Length*LEGO_LENGTH-LEGO_WALL_WIDTH, -EXTRA, LEGO_WALL_WIDTH>
	  }
	}
	
	#local i = 1;
	#while (i < Length)
	  #if (Width = 1)
	    object { SCYLINDER1 translate <i,0,0>*LEGO_LENGTH }
	  #else
	    #local j = 1;
	    #while (j < Width)
	      object { CYLINDER1 translate <i,0,j> * LEGO_LENGTH }
	      #local j = j+1;
	    #end
	  #end
	  #local i = i + 1;
	#end
      }
      
#end

#end
