/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/


#ifndef (GENERICTBRICK1_INC)


    #declare GENERICTBRICK1_INC = 1;

    #include "GenericBrick1.inc"

#macro    GenericTBrick1 (Length, Width)


union {
    difference {
        GenericBrick1 (Length, Width)

        #if ((Length-1) * (Width-1) > 1)
        union {
        #end
            #local i = 1;
            #while (i < Length)
                #local j = 1;
                #while (j < Width)
                    cylinder {
                        (x*i+z*j) * LEGO_LENGTH - y * EXTRA
                        (x*i+z*j) * LEGO_LENGTH + y * (LEGO_HEIGHT + EXTRA)
                        LEGO_KNOB_RADIUS-EXTRA
                    }
                    cylinder {
                        (x*i+z*j) * LEGO_LENGTH + y * (LEGO_HEIGHT - LEGO_CORNER_SPACE/2)
                        (x*i+z*j) * LEGO_LENGTH + y * (LEGO_HEIGHT + 2*EXTRA)
                        LEGO_KNOB_RADIUS+LEGO_CORNER_SPACE/2
                    }
                    #local j = j + 1;
                #end
                #local i = i + 1;
            #end
        #if ((Length-1) * (Width-1) > 1)
            bounded_by { box {
                <0, 0, 0>
                <LEGO_LENGTH*Length, LEGO_HEIGHT, LEGO_LENGTH*Width>
            }}
        }
        #end
    }

    #if ((Length-1) * (Width-1) > 1)
    union {
    #end
        #local i = 1;
        #while (i < Length)
            #local j = 1;
            #while (j < Width)
                torus {
                    LEGO_KNOB_RADIUS + LEGO_CORNER_SPACE/2
                    LEGO_CORNER_SPACE/2
                    translate <i*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE/2, j*LEGO_LENGTH>
                }
                #local j = j + 1;
            #end
            #local i = i + 1;
        #end
    #if ((Length-1) * (Width-1) > 1)
    }
    #end
}


#end
#end
