/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifndef (GENERICTBRICK3_INC)

    #declare GENERICTBRICK3_INC = 1;

    #include "roundbox.inc"

  #macro  GenericTBrick3 (Length)

  difference {
    union {
      difference {
	roundbox (Length*LEGO_LENGTH, 3*LEGO_HEIGHT, 1*LEGO_LENGTH)
	
	object { h_invroundbox(3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT, Length*LEGO_LENGTH-2*LEGO_WALL_WIDTH, 1*LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	  rotate z*90
	  translate <Length*LEGO_LENGTH-LEGO_WALL_WIDTH, -EXTRA, LEGO_WALL_WIDTH>
	}
      }

        object { TKNOB translate <0, 3*LEGO_HEIGHT, 0> }
        #local i = 1;
        #while (i < Length)
            object { SCYLINDER3 translate i*x*LEGO_LENGTH}
            object { LEGO_TUBE translate i*x*LEGO_LENGTH }
            object { TKNOB translate <i*LEGO_LENGTH, 3*LEGO_HEIGHT, 0> }
            #local i = i + 1;
        #end
    }
    #local i = 1;
    #while (i < Length)
        object { LEGO_INV_TUBE translate i*x*LEGO_LENGTH }
        #local i = i + 1;
    #end

    bounded_by { box { <0, 0, 0> <LEGO_LENGTH*Length, LEGO_HEIGHT*3+LEGO_KNOB_HEIGHT, LEGO_LENGTH> } }
}

#end


#end
