/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef (__LEGO_GENERIC_TBRICK_Xx1x1_INC)
#else


  #declare __LEGO_GENERIC_TBRICK_Xx1x1_INC = 1;

  #macro GenericTBrickXx1x1(Length)


  union {
    difference {
      union {
	difference {
	  union {
	    box {
	      <0, 0, LEGO_CORNER_SPACE>
	      <(Length-1) * LEGO_LENGTH, LEGO_HEIGHT, LEGO_LENGTH - LEGO_CORNER_SPACE>
	    }
	    box {
	      <0, LEGO_CORNER_SPACE, 0>
	      <(Length-1)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_LENGTH>
	    }
	    cylinder {
	      <0, LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
	      <(Length-1)*LEGO_LENGTH, LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
	      LEGO_CORNER_SPACE
	    }
	    cylinder {
	      <0, LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
	      <(Length-1)*LEGO_LENGTH, LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
	      LEGO_CORNER_SPACE
	    }
	    cylinder {
	      <0, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
	      <(Length-1)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
	      LEGO_CORNER_SPACE
	    }
	    cylinder {
	      <0, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
	      <(Length-1)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
	      LEGO_CORNER_SPACE
	    }
	    
	    translate x*LEGO_LENGTH/2
	  }
	  
	  box { <-EXTRA, -EXTRA, LEGO_WALL_WIDTH>
	    <Length*LEGO_LENGTH, LEGO_HEIGHT - LEGO_CEILING_HEIGHT, LEGO_LENGTH-LEGO_WALL_WIDTH> }
	  box { <-EXTRA, -EXTRA, -EXTRA> <LEGO_LENGTH + 0.75, 0.5, LEGO_LENGTH+EXTRA> }
	  box { <Length*LEGO_LENGTH + EXTRA, -EXTRA, -EXTRA>
	    <(Length-1)*LEGO_LENGTH-0.75, 0.5, LEGO_LENGTH+EXTRA> }
	  
	}
	
	box { <LEGO_LENGTH + 0.75, 0, LEGO_WALL_WIDTH - EXTRA>
	  <LEGO_LENGTH + 1.75, LEGO_HEIGHT - LEGO_CEILING_HEIGHT + EXTRA, LEGO_LENGTH-LEGO_WALL_WIDTH + EXTRA> }
	box { <(Length-1)*LEGO_LENGTH - 0.75, 0, LEGO_WALL_WIDTH - EXTRA>
	  <(Length-1)*LEGO_LENGTH - 1.75, LEGO_HEIGHT - LEGO_CEILING_HEIGHT + EXTRA, LEGO_LENGTH-LEGO_WALL_WIDTH + EXTRA> }
	
	#local a = 0;
	#while (a < 2)
	  union {
	    cylinder { <0, 0, 0>
	      <0, LEGO_HEIGHT, 0>
	      LEGO_LENGTH/2 - LEGO_CORNER_SPACE
	    }
	    cylinder {
	      <0, LEGO_CORNER_SPACE, 0>
	      <0, LEGO_HEIGHT-LEGO_CORNER_SPACE, 0>
	      LEGO_LENGTH/2
	    }
	    torus {
	      LEGO_LENGTH/2-LEGO_CORNER_SPACE
	      LEGO_CORNER_SPACE
	      translate y * (LEGO_HEIGHT-LEGO_CORNER_SPACE)
	    }
	    torus {
	      LEGO_LENGTH/2-LEGO_CORNER_SPACE
	      LEGO_CORNER_SPACE
	      translate y * LEGO_CORNER_SPACE
	    }
	    bounded_by { box { -<1,0,1>*LEGO_LENGTH/2  <1,0,1>*LEGO_LENGTH/2+y*LEGO_HEIGHT } }
	    
	    translate <LEGO_LENGTH*(0.5+a*(Length-1)), 0, LEGO_LENGTH/2>
	  }
	  #local a = a+1;
	#end

	#local i = 2;
	#while (i < Length-1)
	  object { SCYLINDER1 translate <i,0,0> * LEGO_LENGTH}
	  #local i = i+1;
	#end

	#local i = 1;
	#while (i < Length-1)
	  object { TKNOB translate <i*LEGO_LENGTH, LEGO_HEIGHT, 0> }
	  #local i = i+1;
	#end


      }

      #local a = 0;
      #while (a < 2)
	union {
	  cylinder { <0, -EXTRA, 0>
	    <0, 2*LEGO_HEIGHT, 0>
	    LEGO_KNOB_RADIUS }
	  cylinder { <0, LEGO_HEIGHT-LEGO_CORNER_SPACE/2, 0>
	    <0, 2*LEGO_HEIGHT, 0>
	    LEGO_KNOB_RADIUS+LEGO_CORNER_SPACE/2 }
	  
	  intersection {
	    object { __IKranz translate <0, -LEGO_HEIGHT + 0.8, 0> }
	    cylinder { -y*EXTRA  y*LEGO_HEIGHT  LEGO_LENGTH/2 + EXTRA }
	    bounded_by { cylinder { -y*EXTRA  y*LEGO_HEIGHT   LEGO_LENGTH/2+EXTRA } }
	  }
	  
	  bounded_by { box { <-LEGO_LENGTH/2, -EXTRA, -LEGO_LENGTH/2>
	    <LEGO_LENGTH/2, LEGO_HEIGHT, LEGO_LENGTH/2>  } }
	  
	  translate <(a*(Length-1)+0.5), 0, 0.5> * LEGO_LENGTH
	}
	
	#local a = a+1;
      #end


    }
    #local a = 0;
    #while (a < 2)
      torus {
	LEGO_KNOB_RADIUS+LEGO_CORNER_SPACE/2
	LEGO_CORNER_SPACE/2
	translate <(a*(Length-1)+0.5)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE/2, LEGO_LENGTH/2>
      }
      #local a = a+1;
    #end

    //    bounded_by { box { <0, 0, 0> <Length,0,1>*LEGO_LENGTH+y*(LEGO_HEIGHT+LEGO_KNOB_HEIGHT) }}
  }
  
  
#end
#end
