/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifdef (__LEGO_AXLES_INC)
#else

    #declare __LEGO_AXLES_INC = 1;
    #include "GenericAxle.inc"

#declare CrossAxle2 = GenericAxle (2, LegoBlack)
#declare CrossAxle3 = GenericAxle (3, LegoBlack)
#declare CrossAxle4 = GenericAxle (4, LegoBlack)
#declare CrossAxle5 = GenericAxle (5, LegoBlack)
#declare CrossAxle6 = GenericAxle (6, LegoBlack)
#declare CrossAxle8 = GenericAxle (8, LegoBlack)
#declare CrossAxle10 = GenericAxle (10, LegoBlack)
#declare CrossAxle12 = GenericAxle (12, LegoBlack)
#declare CrossAxle14 = GenericAxle (14, LegoBlack)
#declare CrossAxle16 = GenericAxle (16, LegoBlack)

#declare SteeringLinkage = union {
    difference {
        union {
            object { __IAxle translate x*LEGO_LENGTH scale <2.5,1,1> }
            #local a = 0;
            #while (a < 2)
                union {
                    cylinder {
                        <0, -LEGO_KNOB_RADIUS, 0>
                        <0,  LEGO_KNOB_RADIUS, 0>
                        LEGO_LENGTH/2 - LEGO_CORNER_SPACE
                    }
                    cylinder {
                        <0, -LEGO_KNOB_RADIUS + LEGO_CORNER_SPACE, 0>
                        <0,  LEGO_KNOB_RADIUS - LEGO_CORNER_SPACE, 0>
                        LEGO_LENGTH/2
                    }
                    torus {
                        LEGO_LENGTH/2 - LEGO_CORNER_SPACE
                        LEGO_CORNER_SPACE
                        translate y *(-LEGO_KNOB_RADIUS + LEGO_CORNER_SPACE)
                    }
                    torus {
                        LEGO_LENGTH/2 - LEGO_CORNER_SPACE
                        LEGO_CORNER_SPACE
                        translate y *(LEGO_KNOB_RADIUS - LEGO_CORNER_SPACE)
                    }
                    translate a*x*5*LEGO_LENGTH
                }
                #local a = a + 1;
            #end
        }
        #local a = 0;
        #while (a < 2)
            union {
                cylinder {
                    <0, -LEGO_KNOB_RADIUS*2, 0>
                    <0,  LEGO_KNOB_RADIUS*2, 0>
                    LEGO_SPHERERIVET_RADIUS
                }
                cylinder {
                    <0, -LEGO_KNOB_RADIUS*2, 0>
                    <0, -LEGO_KNOB_RADIUS + LEGO_CORNER_SPACE, 0>
                    LEGO_SPHERERIVET_RADIUS + LEGO_CORNER_SPACE
                }
                cylinder {
                    <0, LEGO_KNOB_RADIUS*2, 0>
                    <0, LEGO_KNOB_RADIUS - LEGO_CORNER_SPACE, 0>
                    LEGO_SPHERERIVET_RADIUS + LEGO_CORNER_SPACE
                }
                translate a*x*5*LEGO_LENGTH
            }
            #local a = a + 1;
        #end
    }
    #local a = 0;
    #while (a < 2)
        union {
            torus {
                LEGO_SPHERERIVET_RADIUS + LEGO_CORNER_SPACE
                LEGO_CORNER_SPACE
                translate y * (-LEGO_KNOB_RADIUS + LEGO_CORNER_SPACE)
            }
            torus {
                LEGO_SPHERERIVET_RADIUS + LEGO_CORNER_SPACE
                LEGO_CORNER_SPACE
                translate y * (LEGO_KNOB_RADIUS - LEGO_CORNER_SPACE)
            }
            translate a*x*5*LEGO_LENGTH
        }
        #local a = a + 1;
    #end

    texture { LegoBlack }
}















#end
