/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef (__HELIX_INC)
#else

  #declare __HELIX_INC = 1;


  
  #macro helix(Radius, Dicke, Laenge, Steigung, Precision)
  
  union {
    
    #local HelixTorus = torus {
      Radius,
      Dicke/2
      rotate z*90
    }
  
    #local HelixSector = intersection {
      box { <-Radius*2, 0, 0> Radius*2 }
      box { <-Radius*2, 0, 0> Radius*2 rotate x*(90 - 360/Precision) }
      rotate x*360/2/Precision
    }

    #local HelixSegment = intersection {
      object { HelixTorus }
      object { HelixSector }
      translate x*Dicke/2
    }


    #local    DX = Steigung / (Precision * sin (2*pi/Precision/2) * Radius * 2);

    
    /*
  #warning concat ("Radius: "  ,  str(Radius,   4, 4))
  #warning concat ("Dicke: ",     str(Dicke,    4, 4))
  #warning concat ("Steigung: ",  str(Steigung, 4, 4))
  #warning concat ("Laenge: ",    str(Laenge,   4, 4))
  #warning concat ("Precision: ", str(Precision,4, 4))
  #warning concat ("DX: ",        str(DX,       4, 4))
  */    
    
    #local i = 0;
    #while (i < Laenge/Steigung*Precision)
      object {
	HelixSegment

	matrix <1.0, 0.0, 0.0,
	        DX,  1.0, 0.0,
         	0.0, 0.0, 1.0,
	        0.0, 0.0, 0.0>


	rotate -x*i*360/Precision
	translate x*i*Steigung/Precision
      }
      #local i = i + 1;
    #end
//    rotate -x*(360/2/Precision)
//    translate x*(l/2 + 2 * Dicke + Steigung/Precision/2)
  }

#end
  
#end

