/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

   inv_round_edge.inc: Inverses zum Erzeugen von runden Kanten an beliebigen Winkeln


 *******************************************************************************/

#ifdef (__INV_ROUND_EDGE_INC)
#else
  
  #declare __INV_ROUND_EDGE_INC = 1;

  
  #macro inv_roundedge(Length, Angle)
    
    inv_roundedgeX(Length, Angle, LEGO_CORNER_SPACE)
    
  #end
  
  
  #macro inv_roundedgeX(Length, Angle, CRadius)


    #if (Angle < 180)

      difference {
	#local __TEMP_x = CRadius / tan (Angle / 2 * pi/180);
	#local __TEMP_alpha = 90 - Angle/2;
	#local __TEMP_h = __TEMP_x * sin (Angle/2*pi/180);
	#local __TEMP_y = __TEMP_x * cos (Angle/2*pi/180);

	box {
	  <0, 0, -2.1*__TEMP_h>
	  <Length, __TEMP_y * 1.1, 0.1*__TEMP_h>
	  rotate -x*__TEMP_alpha
	  translate z*__TEMP_x
	}
	cylinder {
	  <-EXTRA, 0, 0>  <Length, 0, 0>   CRadius
	  translate <0, -CRadius, __TEMP_x> 
	}
	
      }
      
    #else // #if (Angle >= 180)
      
      #error "Not implemented yet :-("
      
    #end 
    
    
  #end
  
#end



