/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifdef (INVROUNDBOX_INC)
#else


  #declare INVROUNDBOX_INC = 1;

  #macro invroundbox (Length, dy, dz)
    
    invroundboxX(Length, dy, dz, LEGO_CORNER_SPACE)
    
  #end

  #macro h_invroundbox (Length, dy, dz)
    
    h_invroundboxX(Length, dy, dz, LEGO_CORNER_SPACE)
    
  #end
    
  #macro invroundboxX (Length, dy, dz, CRadius)
    
    difference {
      union {
	box {
	  <-EXTRA, 0, 0>
	  <Length+EXTRA, dy, dz>
	}
	box {
	  <-CRadius,         -CRadius,   -CRadius>
	  <CRadius,        dy+CRadius, dz+CRadius>
	}
	box {
	  <Length+CRadius,   -CRadius,   -CRadius>
	  <Length-CRadius, dy+CRadius, dz+CRadius>
	}
      }
    
      cylinder {
	<CRadius,  -dy, -CRadius>
	<CRadius, 2*dy, -CRadius>
	CRadius
      }
      cylinder {
	<CRadius,  -dy, dz+CRadius>
	<CRadius, 2*dy, dz+CRadius>
	CRadius
      }
      
      
      cylinder {
	<CRadius, -CRadius,  -dz>
	<CRadius, -CRadius, 2*dz>
	CRadius
      }
      cylinder {
	<CRadius, dy+CRadius,  -dz>
	<CRadius, dy+CRadius, 2*dz>
	CRadius
      }
    
    

      cylinder {
	<Length-CRadius,  -dy, -CRadius>
	<Length-CRadius, 2*dy, -CRadius>
	CRadius
      }
      cylinder {
	<Length-CRadius,  -dy, dz+CRadius>
	<Length-CRadius, 2*dy, dz+CRadius>
	CRadius
      }

      
      cylinder {
	<Length-CRadius, -CRadius,  -dz>
	<Length-CRadius, -CRadius, 2*dz>
	CRadius
      }
      cylinder {
	<Length-CRadius, dy+CRadius,  -dz>
	<Length-CRadius, dy+CRadius, 2*dz>
	CRadius
      }
      
    }
  
  #end
  
  

  #macro h_invroundboxX (Length, dy, dz, CRadius)
    
    difference {
      union {
	box {
	  <-EXTRA, 0, 0>
	  <Length+EXTRA, dy, dz>
	}
	box {
	  <-2*EXTRA,            -CRadius,   -CRadius>
	  <CRadius, dy+CRadius, dz+CRadius>
	}
      }
      
      cylinder {
	<CRadius,  -dy, -CRadius>
	<CRadius, 2*dy, -CRadius>
	CRadius
      }
      cylinder {
	<CRadius,  -dy, dz+CRadius>
	<CRadius, 2*dy, dz+CRadius>
	CRadius
      }
      
      
      cylinder {
	<CRadius, -CRadius,  -dz>
	<CRadius, -CRadius, 2*dz>
	CRadius
      }
      cylinder {
	<CRadius, dy+CRadius,  -dz>
	<CRadius, dy+CRadius, 2*dz>
	CRadius
      }
      
    }
  


  #end

#end
