/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifdef (INVROUNDCYLINDER_INC)
#else


  #declare INVROUNDCYLINDER_INC = 1;

  #macro invroundcylinder (Length, Radius) 
    
    invroundcylinderX(Length, Radius, LEGO_CORNER_SPACE)
    
  #end

  #macro h_invroundcylinder (Length, Radius) 
    
    h_invroundcylinderX(Length, Radius, LEGO_CORNER_SPACE)
    
  #end

  #macro invroundcylinderX (Length, Radius, CRadius) 
    
    difference {
      union {
	cylinder {
	  <-EXTRA, 0, 0>
	  <Length+EXTRA, 0, 0>
	  Radius
	}
	cylinder {
	  <-2*EXTRA, 0, 0>
	  <CRadius, 0, 0>
	  Radius+CRadius
	}
	cylinder {
	  <Length+2*EXTRA, 0, 0>
	  <Length-CRadius, 0, 0>
	  Radius+CRadius
	}
      }
      
      torus { 
	Radius + CRadius
	CRadius
	rotate z*90
	translate x*CRadius
      }
      torus { 
	Radius + CRadius
	CRadius
	rotate z*90
	translate x*(Length - CRadius)
      }
      
    }
  
  #end

  #macro h_invroundcylinderX (Length, Radius, CRadius) 
    
    difference {
      union {
	cylinder {
	  <-EXTRA, 0, 0>
	  <Length+EXTRA, 0, 0>
	  Radius-CRadius/2
	}
	cylinder {
	  <-EXTRA, 0, 0>
	  <Length-CRadius/2, 0, 0>
	  Radius
	}
	torus {
	  Radius-CRadius/2
	  CRadius/2
	  rotate z*90
	  translate x*(Length-CRadius/2)
	}
	cylinder {
	  <-2*EXTRA, 0, 0>
	  <CRadius, 0, 0>
	  Radius+CRadius
	}
      }
      
      torus { 
	Radius + CRadius
	CRadius
	rotate z*90
	translate x*CRadius
      }
    }

  #end

#end
