/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

   LEGO_COLORS.INC: textures for LEGO for POV-Ray

 *******************************************************************************/

#ifdef (__LEGO_COLORS_INC)
#else

  #declare __LEGO_COLORS_INC = 1;

  #include "colors.inc"
  #include "metals.inc"


  #declare LEGO_FINISH = finish {
    ambient 0.4
    phong 0.1
    phong_size 1
    diffuse 0.5
    reflection 0.05
  }



  #declare LEGO_CLEAR_FINISH = finish {
    ambient 0.3
    diffuse 0.3
    reflection 0.05
    phong 0
    phong_size 0
  }
  
  #declare LEGO_CLEAR_INTERIOR = interior {
    ior 1.5    
  }


  #declare LegoRed = texture {
    pigment { rgb <0.9, 0.1, 0> }
    finish { LEGO_FINISH }
  }

  #declare LegoRedClear = material {
    interior { LEGO_CLEAR_INTERIOR }
    texture { 
      pigment { rgbt <0.9, 0.1, 0, 0.9> }
      finish { LEGO_CLEAR_FINISH }
    }
  }


  #declare LegoYellow = texture {
    pigment { rgb <0.95, 0.75, 0> }
    finish { LEGO_FINISH }
  }


  #declare LegoBlue = texture {
    pigment { rgb <0.1, 0.15, 0.9> }
    finish { LEGO_FINISH }
  }

  #declare LegoGreen = texture {
    pigment { rgb <0.15, 0.6, 0.15> }
    finish { LEGO_FINISH }
  }

  #declare LegoBlack = texture {
    pigment { Gray15 }
    finish { LEGO_FINISH }
  }

  #declare LegoWhite = texture {
    pigment { White }
    finish { LEGO_FINISH }
  }

  #declare LegoGray = texture {
    pigment { color Gray65 }
    finish { LEGO_FINISH }
  }

  #declare LegoDarkGray = texture {
    pigment { color Gray40 }
    finish { LEGO_FINISH }
  }



#end
