/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef (__LEGO_RBRICKS_INC)
#else

  #declare __LEGO_RBRICKS_INC = 1;


  #include "invroundbox.inc"
  #include "roundbox.inc"
  #include "invroundcylinder.inc"
  #include "roundcylinder.inc"
  #include "inv_round_edge.inc"
  #include "roundcone.inc"
  
  
  #macro __tmp_r2x2xX(Height) 

  union {
    difference {
      object { roundcylinder      (Height-LEGO_KNOB_HEIGHT, LEGO_LENGTH)        
	rotate z*90 translate <LEGO_LENGTH, LEGO_KNOB_HEIGHT, LEGO_LENGTH> }
      object { h_invroundcylinder (Height-LEGO_CEILING_HEIGHT-LEGO_KNOB_HEIGHT, LEGO_LENGTH-LEGO_WALL_WIDTH) 
	rotate z*90 translate <LEGO_LENGTH, LEGO_KNOB_HEIGHT,LEGO_LENGTH> }
    }

    difference {
      object { h_roundcylinder (LEGO_HEIGHT-LEGO_CEILING_HEIGHT/2, LEGO_LENGTH)
	rotate z*90 translate <LEGO_LENGTH, 0, LEGO_LENGTH> }
      object { h_invroundbox (LEGO_KNOB_HEIGHT*3, 2*LEGO_LENGTH-2*LEGO_WALL_WIDTH, 2*LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	rotate z*90
	translate <2*LEGO_LENGTH-LEGO_WALL_WIDTH, 0, LEGO_WALL_WIDTH> }
    
      #local __phi = 180/pi*acos((LEGO_LENGTH-LEGO_WALL_WIDTH)/LEGO_LENGTH);
      #local i = 0;
      #while (i < 4) 
	object { inv_roundedge(LEGO_KNOB_HEIGHT*3, __phi)
	  rotate z*90
	  rotate y*90
	  translate z*LEGO_LENGTH
	  rotate -y*__phi
	  rotate y*i*90
	  translate <LEGO_LENGTH, -EXTRA, LEGO_LENGTH>
	}
	object { inv_roundedge(LEGO_KNOB_HEIGHT*3, __phi) 
	  rotate z*90
	  rotate y*90
	  translate z*LEGO_LENGTH
	  rotate -y*__phi
	  scale <-1,1,1>
	  rotate y*i*90
	  translate <LEGO_LENGTH, -EXTRA, LEGO_LENGTH>
	}
	#local i=i+1;
      #end
    }
  }  
  
#end


#declare  r2x2x3p = intersection {
  union {
    difference {
      union {
	__tmp_r2x2xX (3*LEGO_HEIGHT)
	object { roundbox(1, LEGO_KNOB_HEIGHT, 2*LEGO_LENGTH-LEGO_WALL_WIDTH)
	  translate <LEGO_LENGTH-0.5, 3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT-LEGO_KNOB_HEIGHT, LEGO_WALL_WIDTH/2> }
	object { roundbox(2*LEGO_LENGTH-LEGO_WALL_WIDTH, LEGO_KNOB_HEIGHT, 1)
	  translate <LEGO_WALL_WIDTH/2, 3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT-LEGO_KNOB_HEIGHT, LEGO_LENGTH-0.5> }
	object { h_roundcylinder(3*LEGO_HEIGHT-EXTRA, LEGO_CYLINDER_RADIUS) 
	  rotate z*90
	  translate <LEGO_LENGTH, 0, LEGO_LENGTH> }
      }
      object { h_invroundcylinder (LEGO_KNOB_HEIGHT, LEGO_KNOB_RADIUS)
	rotate z*90
	translate <LEGO_LENGTH, 0, LEGO_LENGTH> }
      object { __IAxle  scale <2,1,1> rotate  z*90 translate <LEGO_LENGTH, 0, LEGO_LENGTH> }
      intersection {
	object { __INV_ROUND_AXLE }
	cylinder { <-LEGO_LENGTH, 0, 0> <LEGO_LENGTH, 0, 0> LEGO_KNOB_RADIUS }
	rotate -z*90 translate <LEGO_LENGTH, LEGO_KNOB_HEIGHT, LEGO_LENGTH> 
      }
      object { __INV_ROUND_AXLE rotate z*90 translate <LEGO_LENGTH, 3*LEGO_HEIGHT, LEGO_LENGTH> }
      
    }
    object { KNOB translate <0*LEGO_LENGTH, 3*LEGO_HEIGHT, 0*LEGO_LENGTH> }
    object { KNOB translate <1*LEGO_LENGTH, 3*LEGO_HEIGHT, 0*LEGO_LENGTH> }
    object { KNOB translate <0*LEGO_LENGTH, 3*LEGO_HEIGHT, 1*LEGO_LENGTH> }
    object { KNOB translate <1*LEGO_LENGTH, 3*LEGO_HEIGHT, 1*LEGO_LENGTH> }
  }
  cylinder { <LEGO_LENGTH, -1, LEGO_LENGTH> <LEGO_LENGTH, 3*LEGO_HEIGHT+2*LEGO_KNOB_HEIGHT, LEGO_LENGTH>  LEGO_LENGTH+EXTRA }
  translate <-LEGO_LENGTH, 0, -LEGO_LENGTH>
}






#local __tmp_r2x2x1Y = difference {
  union {
    __tmp_r2x2xX(LEGO_HEIGHT)
    object { roundbox(1, LEGO_HEIGHT-LEGO_CEILING_HEIGHT-LEGO_KNOB_HEIGHT, 2*LEGO_LENGTH-LEGO_WALL_WIDTH)
      translate <LEGO_LENGTH-0.5, LEGO_KNOB_HEIGHT, LEGO_WALL_WIDTH/2> }
    object { roundbox(2*LEGO_LENGTH-LEGO_WALL_WIDTH, LEGO_HEIGHT-LEGO_CEILING_HEIGHT-LEGO_KNOB_HEIGHT, 1)
      translate <LEGO_WALL_WIDTH/2, LEGO_KNOB_HEIGHT, LEGO_LENGTH-0.5> }
    object { h_roundcylinder(LEGO_HEIGHT-EXTRA, LEGO_CYLINDER_RADIUS) 
      rotate z*90
      translate <LEGO_LENGTH, 0, LEGO_LENGTH> }
  }
  object { h_invroundcylinder(LEGO_KNOB_HEIGHT/3, LEGO_KNOB_RADIUS)
    rotate z*90
    translate <LEGO_LENGTH, -EXTRA, LEGO_LENGTH> }
  intersection {
    object { __INV_ROUND_AXLE }
    cylinder { <-LEGO_LENGTH, 0, 0> <LEGO_LENGTH, 0, 0> LEGO_KNOB_RADIUS }
    rotate -z*90 translate <LEGO_LENGTH, LEGO_KNOB_HEIGHT/3, LEGO_LENGTH> 
  }
}

#declare r2x2x1p = intersection {
  union {
    difference {
      object { __tmp_r2x2x1Y }
      object { __IAxle  rotate  z*90 translate <LEGO_LENGTH, 0, LEGO_LENGTH> }
      object { __INV_ROUND_AXLE rotate z*90 translate <LEGO_LENGTH, LEGO_HEIGHT, LEGO_LENGTH> }
    }
    object { KNOB translate <0*LEGO_LENGTH, LEGO_HEIGHT, 0*LEGO_LENGTH> }
    object { KNOB translate <1*LEGO_LENGTH, LEGO_HEIGHT, 0*LEGO_LENGTH> }
    object { KNOB translate <0*LEGO_LENGTH, LEGO_HEIGHT, 1*LEGO_LENGTH> }
    object { KNOB translate <1*LEGO_LENGTH, LEGO_HEIGHT, 1*LEGO_LENGTH> }
  }
  cylinder { <LEGO_LENGTH, -1, LEGO_LENGTH> <LEGO_LENGTH, 3*LEGO_HEIGHT+2*LEGO_KNOB_HEIGHT, LEGO_LENGTH>  LEGO_LENGTH+EXTRA }
  translate <-LEGO_LENGTH, 0, -LEGO_LENGTH>
}


#declare r2x2x1f = intersection {
  difference {
    object { __tmp_r2x2x1Y }
    intersection {
      object { __IAxle }
      box { <0, -LEGO_LENGTH, -LEGO_LENGTH> LEGO_LENGTH }
      rotate -z*90  translate <LEGO_LENGTH, LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH> 
    }
  }
  cylinder { <LEGO_LENGTH, -1, LEGO_LENGTH> <LEGO_LENGTH, 3*LEGO_HEIGHT+2*LEGO_KNOB_HEIGHT, LEGO_LENGTH>  LEGO_LENGTH+EXTRA }
  translate <-LEGO_LENGTH, 0, -LEGO_LENGTH>
}


  
  #declare rc2x2x6p = union {
    difference {
      union {
	object { RoundCone(LEGO_LENGTH, LEGO_LENGTH/2, LEGO_HEIGHT*6-LEGO_KNOB_HEIGHT)
	  translate y*LEGO_KNOB_HEIGHT }
	object { h_roundcylinder (LEGO_KNOB_HEIGHT, LEGO_KNOB_RADIUS)
	  rotate -z*90
	  translate y*(LEGO_HEIGHT*6+LEGO_KNOB_HEIGHT) }
      }
      cone {
	<0,LEGO_KNOB_HEIGHT-EXTRA,0>           LEGO_LENGTH-LEGO_WALL_WIDTH
	<0,LEGO_HEIGHT*6-LEGO_CEILING_HEIGHT,0> LEGO_LENGTH/2-LEGO_WALL_WIDTH+LEGO_LENGTH/2/(LEGO_HEIGHT*6-LEGO_KNOB_HEIGHT)*LEGO_CEILING_HEIGHT 
      }
      #local __phi=180/pi*atan2(6*LEGO_HEIGHT-LEGO_KNOB_HEIGHT, -LEGO_LENGTH/2);
      object { invround_coneedge(LEGO_LENGTH-LEGO_WALL_WIDTH, __phi, -(180-__phi)) 
	translate y*LEGO_KNOB_HEIGHT }
      object { h_invroundcylinder(LEGO_KNOB_HEIGHT+LEGO_CEILING_HEIGHT*2, LEGO_KNOB_INNER_RADIUS)
	rotate -z*90
	translate y*(LEGO_HEIGHT*6+LEGO_KNOB_HEIGHT) }
    }
    intersection {
      union {
	difference {
	  object { h_roundcylinder(LEGO_KNOB_HEIGHT+LEGO_CORNER_SPACE*2, LEGO_LENGTH)
	    rotate z*90 }
	  object { h_invroundbox(LEGO_KNOB_HEIGHT*2, LEGO_LENGTH*2-2*LEGO_WALL_WIDTH, LEGO_LENGTH*2-2*LEGO_WALL_WIDTH)
	    rotate z*90 translate <LEGO_LENGTH-LEGO_WALL_WIDTH, 0, -LEGO_LENGTH+LEGO_WALL_WIDTH> }
	  #local __phi = 180/pi*acos((LEGO_LENGTH-LEGO_WALL_WIDTH)/LEGO_LENGTH);
	  #local i = 0;
	  #while (i < 4) 
	    object { inv_roundedge(LEGO_KNOB_HEIGHT*3, __phi)
	      rotate z*90
	      rotate y*90
	      translate <0, -EXTRA, LEGO_LENGTH>
	      rotate -y*__phi
	      rotate y*i*90
	    }
	    object { inv_roundedge(LEGO_KNOB_HEIGHT*3, __phi) 
	      rotate z*90
	      rotate y*90
	      translate <0, -EXTRA, LEGO_LENGTH>
	      rotate -y*__phi
	      scale <-1,1,1>
	      rotate y*i*90
	    }
	    #local i=i+1;
	  #end
	}
	difference {
	  union {
	    object { h_roundbox(LEGO_LENGTH*2, LEGO_HEIGHT*6-LEGO_KNOB_HEIGHT-LEGO_CEILING_HEIGHT, 1)
	      scale <1,-1,1>
	      translate <-LEGO_LENGTH, LEGO_HEIGHT*6-LEGO_CEILING_HEIGHT, -0.5> }
	    object { h_roundcylinder(LEGO_HEIGHT*6-LEGO_CEILING_HEIGHT, LEGO_CYLINDER_RADIUS)
	      rotate z*90 }
	  }
	  object { h_invroundcylinder(LEGO_HEIGHT*4, LEGO_KNOB_RADIUS)
	    rotate z*90 }
	  object { __IAxle rotate z*90 translate y*(LEGO_LENGTH+3*LEGO_HEIGHT) }
	}
	      
	
      }
      cone {
	<0, -EXTRA, 0> LEGO_LENGTH/2+LEGO_LENGTH/2/(LEGO_HEIGHT*6-LEGO_KNOB_HEIGHT) * LEGO_HEIGHT*6
	<0, LEGO_HEIGHT*6, 0> LEGO_LENGTH/2
      }
    }
  
  }
  

#end
