/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifdef (__LEGO_RIVETS_INC)
#else

    #declare __LEGO_RIVETS_INC = 1;

  
  #include "invround_coneedge.inc"
  #include "roundcylinder.inc"
  #include "invroundbox.inc"


  #declare RIVET = difference {
    union {
      cylinder { <-LEGO_LENGTH, 0, 0> <LEGO_LENGTH, 0, 0> LEGO_KNOB_RADIUS }
      object { roundcylinder(LEGO_WALL_WIDTH, LEGO_TUBE_INLAY_RADIUS) translate -x*LEGO_WALL_WIDTH/2 }
      
      
      object { invround_coneedgeX(LEGO_KNOB_RADIUS, 90, -90, LEGO_CORNER_SPACE/2)
	rotate z*90 translate -x*LEGO_WALL_WIDTH/2  }
      object { invround_coneedgeX(LEGO_KNOB_RADIUS, 90, -90, LEGO_CORNER_SPACE/2)
	rotate -z*90 translate x*LEGO_WALL_WIDTH/2  }
	  
      object { roundcylinder(LEGO_RIVET_END_WIDTH, LEGO_RIVET_END_RADIUS) translate -x*LEGO_LENGTH }
      object { roundcylinder(LEGO_RIVET_END_WIDTH, LEGO_RIVET_END_RADIUS) translate -x*LEGO_LENGTH scale <-1,1,1>}
    }
    object { invroundcylinder(2*LEGO_LENGTH, LEGO_KNOB_RADIUS-LEGO_RIVET_WALL_WIDTH) translate -x*LEGO_LENGTH }

    object { invroundcylinder(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH/2) rotate -y*90 translate <-LEGO_GAP_LENGTH, 0, -LEGO_KNOB_RADIUS> } 
    object { invroundcylinder(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH/2) rotate -y*90 translate < LEGO_GAP_LENGTH, 0, -LEGO_KNOB_RADIUS> } 
    object { invroundcylinder(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH/2) rotate  z*90 translate <-LEGO_LENGTH+LEGO_GAP_LENGTH, -LEGO_KNOB_RADIUS, 0> }
    object { invroundcylinder(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH/2) rotate  z*90 translate <+LEGO_LENGTH-LEGO_GAP_LENGTH, -LEGO_KNOB_RADIUS, 0> }
    
    difference {
      object { invroundbox(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH, LEGO_GAP_LENGTH*2)
	rotate -y*90
	translate <LEGO_GAP_LENGTH, -LEGO_GAP_WIDTH/2, -LEGO_KNOB_RADIUS> }
      cylinder { <-LEGO_WALL_WIDTH/2-LEGO_CORNER_SPACE/2, 0, 0> <LEGO_WALL_WIDTH/2+LEGO_CORNER_SPACE/2, 0, 0> LEGO_LENGTH }
    }
    object  { invroundbox(LEGO_TUBE_INLAY_RADIUS*2, LEGO_GAP_WIDTH-EXTRA*2, LEGO_WALL_WIDTH*2) 
      rotate -y*90 
      translate <LEGO_WALL_WIDTH, -LEGO_GAP_WIDTH/2+EXTRA, -LEGO_TUBE_INLAY_RADIUS> }
    
    intersection {
      union {
	object { invroundbox(LEGO_KNOB_RADIUS*2, LEGO_GAP_LENGTH-LEGO_RIVET_END_WIDTH, LEGO_GAP_WIDTH-EXTRA*2) 
	  rotate -z*90
	  translate <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, LEGO_KNOB_RADIUS, -LEGO_GAP_WIDTH/2+EXTRA>
	}
	object { invroundbox(LEGO_KNOB_RADIUS*2, LEGO_GAP_LENGTH-LEGO_RIVET_END_WIDTH, LEGO_GAP_WIDTH-EXTRA*2) 
	  rotate -z*90
	  translate <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, LEGO_KNOB_RADIUS, -LEGO_GAP_WIDTH/2+EXTRA>
	  scale <-1,1,1>
	}
      }
      cylinder { <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, 0, 0> <LEGO_LENGTH-LEGO_RIVET_END_WIDTH, 0, 0> LEGO_LENGTH }
    }
    object { h_invroundbox(LEGO_GAP_LENGTH, LEGO_RIVET_END_RADIUS*2, LEGO_GAP_WIDTH) 
      translate <-LEGO_LENGTH,-LEGO_RIVET_END_RADIUS, -LEGO_GAP_WIDTH/2> }
    object { h_invroundbox(LEGO_GAP_LENGTH, LEGO_RIVET_END_RADIUS*2, LEGO_GAP_WIDTH) 
      translate <-LEGO_LENGTH,-LEGO_RIVET_END_RADIUS, -LEGO_GAP_WIDTH/2> 
      scale <-1,1,1>}
    
    bounded_by { cylinder { <-LEGO_LENGTH, 0, 0> <LEGO_LENGTH, 0, 0> LEGO_TUBE_INLAY_RADIUS }}
  }
  


  #declare RivetBlack = object {
    RIVET
    texture { LegoBlack }
  }



  #declare RivetGray = object {
    RIVET
    texture { LegoGray }
  }



  #declare CrossRivet = difference {
    union {
      intersection {
	object { GenericAxle (2, LegoGray)
	  translate -x*LEGO_LENGTH }
	box { (-y-z)*(LEGO_KNOB_RADIUS+1)   x*(LEGO_LENGTH+1)+(y+z)*(LEGO_KNOB_RADIUS+1) }
      }
      cylinder { <-LEGO_LENGTH, 0, 0> <0, 0, 0> LEGO_KNOB_RADIUS }
      object { roundcylinder (LEGO_WALL_WIDTH/2, LEGO_TUBE_INLAY_RADIUS) scale <-1,1,1> }
      
      
      object { invround_coneedgeX(LEGO_KNOB_RADIUS, 90, -90, LEGO_CORNER_SPACE/2)
	rotate z*90 translate -x*LEGO_WALL_WIDTH/2  }
      
      object { roundcylinder (LEGO_RIVET_END_WIDTH, LEGO_RIVET_END_RADIUS)
	translate -x*LEGO_LENGTH }
    }
	
    object { h_invroundcylinder(LEGO_LENGTH, LEGO_KNOB_RADIUS - LEGO_RIVET_WALL_WIDTH)
      translate -x*LEGO_LENGTH }
    

    object { invroundcylinder(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH/2) rotate  z*90 translate <-LEGO_LENGTH+LEGO_GAP_LENGTH, -LEGO_KNOB_RADIUS, 0> }

    intersection {
      object { invroundbox(LEGO_KNOB_RADIUS*2, LEGO_GAP_LENGTH-LEGO_RIVET_END_WIDTH, LEGO_GAP_WIDTH-EXTRA*2) 
	rotate -z*90
	translate <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, LEGO_KNOB_RADIUS, -LEGO_GAP_WIDTH/2+EXTRA>
      }
      cylinder { <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, 0, 0> <LEGO_LENGTH-LEGO_RIVET_END_WIDTH, 0, 0> LEGO_LENGTH }
    }
    object { h_invroundbox(LEGO_GAP_LENGTH, LEGO_RIVET_END_RADIUS*2, LEGO_GAP_WIDTH) 
      translate <-LEGO_LENGTH,-LEGO_RIVET_END_RADIUS, -LEGO_GAP_WIDTH/2> }
    
    texture { LegoGray }
    bounded_by { cylinder { <-LEGO_LENGTH, 0, 0> <LEGO_LENGTH, 0, 0> LEGO_TUBE_INLAY_RADIUS } }
  }





  #declare HalfRivet = difference {
    union {
      object { h_roundcylinder(LEGO_LENGTH+LEGO_KNOB_HEIGHT, LEGO_KNOB_RADIUS)
	translate -x*LEGO_KNOB_HEIGHT
	scale <-1,1,1>
      }
      
      object { roundcylinder(LEGO_WALL_WIDTH/2, LEGO_TUBE_INLAY_RADIUS)
	scale <-1,1,1> }

      object { invround_coneedgeX(LEGO_KNOB_RADIUS, 90, -90, LEGO_CORNER_SPACE/2)
	rotate z*90 translate -x*LEGO_WALL_WIDTH/2   }
      object { invround_coneedgeX(LEGO_KNOB_RADIUS, 90, -90, LEGO_CORNER_SPACE/2)
	rotate -z*90 }
      
      object { roundcylinder (LEGO_RIVET_END_WIDTH, LEGO_RIVET_END_RADIUS)
	translate -x*LEGO_LENGTH }
    }
    
    object { invroundcylinder(LEGO_LENGTH+LEGO_KNOB_HEIGHT, LEGO_KNOB_RADIUS - LEGO_RIVET_WALL_WIDTH)
      translate -x*LEGO_LENGTH }

    object { invroundcylinder(LEGO_KNOB_RADIUS*2, LEGO_GAP_WIDTH/2) rotate  z*90 translate <-LEGO_LENGTH+LEGO_GAP_LENGTH, -LEGO_KNOB_RADIUS, 0> }

    intersection {
      object { invroundbox(LEGO_KNOB_RADIUS*2, LEGO_GAP_LENGTH-LEGO_RIVET_END_WIDTH, LEGO_GAP_WIDTH-EXTRA*2) 
	rotate -z*90
	translate <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, LEGO_KNOB_RADIUS, -LEGO_GAP_WIDTH/2+EXTRA>
      }
      cylinder { <-LEGO_LENGTH+LEGO_RIVET_END_WIDTH, 0, 0> <LEGO_LENGTH-LEGO_RIVET_END_WIDTH, 0, 0> LEGO_LENGTH }
    }
    object { h_invroundbox(LEGO_GAP_LENGTH, LEGO_RIVET_END_RADIUS*2, LEGO_GAP_WIDTH) 
      translate <-LEGO_LENGTH,-LEGO_RIVET_END_RADIUS, -LEGO_GAP_WIDTH/2> }
    
    texture { LegoGray }
    bounded_by { cylinder { <-LEGO_LENGTH, 0, 0> <LEGO_KNOB_HEIGHT, 0, 0> LEGO_TUBE_INLAY_RADIUS }}
  }



  #declare SphereRivet = union {
    intersection {
      object { GenericAxle (2, LegoGray)
	translate -x*LEGO_LENGTH }
      box { (-y-z)*(LEGO_KNOB_RADIUS+1)   x*(LEGO_LENGTH+1)+(y+z)*(LEGO_KNOB_RADIUS+1) }
    }

    object { roundcylinder (LEGO_WALL_WIDTH/2, LEGO_TUBE_INLAY_RADIUS) }
    
    
    object { invround_coneedgeX(1.6, 90, -90, LEGO_CORNER_SPACE/2)
      rotate z*90 }
    
    cylinder { <-LEGO_SPHERERIVET_CENTER, 0, 0> <0, 0, 0> 1.6 }
    sphere { <-LEGO_SPHERERIVET_CENTER, 0, 0> LEGO_SPHERERIVET_RADIUS }

    texture { LegoGray }
  }



#end
