/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifdef (ROUNDBOX_INC)
#else


  #declare ROUNDBOX_INC = 1;

  #macro roundbox (Length, Height, Width)
    
    roundboxX(Length, Height, Width, LEGO_CORNER_SPACE)
    
  #end
  
  #macro h_roundbox (Length, Height, Width)
    
    h_roundboxX(Length, Height, Width, LEGO_CORNER_SPACE)
    
  #end
  
  #macro roundboxX (Length, Height, Width, CRadius)
  
    #local __CORNER_SPACE = CRadius;
    #while ((2*__CORNER_SPACE > Height) | (2*__CORNER_SPACE > Width) | (2*__CORNER_SPACE > Length))
      #local __CORNER_SPACE = __CORNER_SPACE / 2;
    #end

    union {
      box {
	<0, 0, 0>
	+ <1, 1, 0> * __CORNER_SPACE
	<Length, Height, Width>
	- <1, 1, 0> * __CORNER_SPACE
      }
      box {
	<0, 0, 0>
	+ <1, 0, 1> * __CORNER_SPACE
	<Length, Height, Width>
	- <1, 0, 1> * __CORNER_SPACE
      }
      box {
	<0, 0, 0>
	+ <0, 1, 1> * __CORNER_SPACE
	<Length, Height, Width>
	- <0, 1, 1> * __CORNER_SPACE
      }
      
      
      
      sphere {
	<0*Length, 0*Height, 0*Width>
	+ <1, 1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<1*Length, 0*Height, 0*Width>
	+ <-1, 1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      sphere {
	<0*Length, 0*Height, 1*Width>
	+ <1, 1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<1*Length, 0*Height, 1*Width>
	+ <-1, 1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      cylinder {
	<0*Length, 0*Height, 0*Width>
	+ <1, 1, 1> * __CORNER_SPACE
	<1*Length, 0*Height, 0*Width>
	+ <-1, 1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<0*Length, 0*Height, 0*Width>
	+ <1, 1, 1> * __CORNER_SPACE
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	<1*Length, 0*Height, 0*Width>
	+ <-1, 1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
    
    
    
      cylinder {
	<0*Length, 0*Height, 0*Width>
	+ <1, 1, 1> * __CORNER_SPACE
	<0*Length, 0*Height, 1*Width>
	+ <1, 1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 0*Height, 0*Width>
	+ <-1, 1, 1> * __CORNER_SPACE
	<1*Length, 0*Height, 1*Width>
	+ <-1, 1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      cylinder {
	<0*Length, 0*Height, 1*Width>
	+ <1, 1, -1> * __CORNER_SPACE
	<1*Length, 0*Height, 1*Width>
	+ <-1, 1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<0*Length, 0*Height, 1*Width>
	+ <1, 1, -1> * __CORNER_SPACE
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	<1*Length, 0*Height, 1*Width>
	+ <-1, 1, -1> * __CORNER_SPACE
      __CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	<0*Length, 1*Height, 1*Width>
      + <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      bounded_by { box { <0, 0, 0> <Length, Height, Width> } }
    }
  
  
  #end



  //half round box, rounded on the top (y==Height)
  
  #macro h_roundboxX (Length, Height, Width, CRadius)

    #local __CORNER_SPACE = CRadius;
    #while ((2*__CORNER_SPACE > Height) | (2*__CORNER_SPACE > Width) | (2*__CORNER_SPACE > Length))
      #local __CORNER_SPACE = __CORNER_SPACE / 2;
    #end
    
    union {
      box {
	<0, 0, 0>
	+ <1, 0, 0> * __CORNER_SPACE
	<Length, Height, Width>
	- <1, 1, 0> * __CORNER_SPACE
      }
      box {
	<0, 0, 0>
	+ <1, 0, 1> * __CORNER_SPACE
	<Length, Height, Width>
	- <1, 0, 1> * __CORNER_SPACE
      }
      box {
	<0, 0, 0>
	+ <0, 0, 1> * __CORNER_SPACE
	<Length, Height, Width>
	- <0, 1, 1> * __CORNER_SPACE
      }
      
      
      
      sphere {
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      sphere {
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      sphere {
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      cylinder {
	<0*Length, 0*Height, 0*Width>
	+ <1, 0, 1> * __CORNER_SPACE
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	<1*Length, 0*Height, 0*Width>
	+ <-1, 0, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      
      
      cylinder {
	<1*Length, 1*Height, 0*Width>
	+ <-1, -1, 1> * __CORNER_SPACE
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<0*Length, 1*Height, 0*Width>
	+ <1, -1, 1> * __CORNER_SPACE
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      
      
      cylinder {
	<0*Length, 0*Height, 1*Width>
	+ <1, 0, -1> * __CORNER_SPACE
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	<1*Length, 0*Height, 1*Width>
	+ <-1, 0, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
      cylinder {
	<1*Length, 1*Height, 1*Width>
	+ <-1, -1, -1> * __CORNER_SPACE
	<0*Length, 1*Height, 1*Width>
	+ <1, -1, -1> * __CORNER_SPACE
	__CORNER_SPACE
      }
    }
  
    
  #end
  

#end
