/*******************************************************************************

                        LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/


#ifdef (ROUNDCONE_INC)
#else
  
  #declare ROUNDCONE_INC = 1;
  
  #include "invround_coneedge.inc"

  #macro RoundCone (Radius1, Radius2, Height)
    RoundConeX (Radius1, Radius2, Height, LEGO_CORNER_SPACE)
  #end
  
  
  #macro RoundConeX (Radius1, Radius2, Height, CRadius)

    difference {
      cone { <0, 0, 0> Radius1 <0, Height, 0> Radius2 }

      #local __TEMP_phi = 180/pi*atan2 (Height, Radius1 - Radius2);
      object { invround_coneedgeX(Radius1, __TEMP_phi, 0, CRadius) }
      object { invround_coneedgeX(Radius2, 180-__TEMP_phi, 180-__TEMP_phi, CRadius) 
	translate y*Height }
	
    }

  
  #end

#end
