/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifdef (ROUNDCYLINDER_INC)
#else


  #declare ROUNDCYLINDER_INC = 1;

  #macro roundcylinder (Length, Radius)
    
    roundcylinderX(Length, Radius, LEGO_CORNER_SPACE)

  #end

  #macro h_roundcylinder (Length, Radius)
    
    h_roundcylinderX(Length, Radius, LEGO_CORNER_SPACE)
    
  #end

  
  #macro roundcylinderX (Length, Radius, CRadius)
    
    #while (Length-2*CRadius <= 0)
      #local CRadius = CRadius/2;
    #end

    union {
      cylinder {
	<0, 0, 0>
	<Length, 0, 0>
	Radius - CRadius
      }
      cylinder {
	<CRadius, 0, 0>
	<Length-CRadius, 0, 0>
	Radius
      }
      torus {
	Radius - CRadius
	CRadius
	rotate z*90
	translate x*CRadius
      }
      torus {
	Radius - CRadius
	CRadius
	rotate z*90
	translate x*(Length - CRadius)
      }
    }
    
  #end
  



  #macro h_roundcylinderX (Length, Radius, CRadius)
    
    #while (Length-CRadius <= 0)
      #local CRadius = CRadius/2;
    #end

    union {
      cylinder {
        <0, 0, 0>
	<Length-EXTRA, 0, 0>
	Radius - CRadius
      }
      cylinder {
	<CRadius, 0, 0>
	<Length, 0, 0>
	Radius
      }
      torus {
	Radius - CRadius
	CRadius
	rotate z*90
	translate x*CRadius
      }
    }

  #end

#end