/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef (__LEGO_ROUNDTUBE_INC)
#else

  #declare __LEGO_ROUNDTUBE_INC = 1;


  #include "roundcylinder.inc"
  #include "invroundcylinder.inc"

  #macro roundtube(Length, Radius, InnerRadius)

    roundtubeX(Length, Radius, InnerRadius, LEGO_CORNER_SPACE)
    
  #end
  
  #macro h_roundtube(Length, Radius, InnerRadius)
  
    h_roundtubeX(Length, Radius, InnerRadius, LEGO_CORNER_SPACE)
    
  #end
  
  
  #macro roundtubeX(Length, Radius, InnerRadius, CRadius)
  
    difference {
      object { roundcylinderX(Length, Radius, CRadius) }
      object { invroundcylinderX (Length, InnerRadius, CRadius) }
    }
  
  #end

  #macro h_roundtubeX(Length, Radius, InnerRadius, CRadius)
  
    difference {
      object { h_roundcylinderX(Length, Radius, CRadius) }
      object { h_invroundcylinderX (Length+EXTRA, InnerRadius, CRadius) }
    }

  #end

#end
