/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.


 *******************************************************************************/

#ifndef (__LEGO_TBRICKSXxXx1_INC)

    #declare __LEGO_TBRICKSXxXx1_INC = 1;

    #include "GenericTBrick1.inc"

#declare t2x2x1p  = GenericTBrick1(2,2)
#declare t3x2x1p  = GenericTBrick1(3,2)
#declare t4x2x1p  = GenericTBrick1(4,2)
#declare t6x2x1p  = GenericTBrick1(6,2)
#declare t8x2x1p  = GenericTBrick1(8,2)
#declare t10x2x1p = GenericTBrick1(10,2)
#declare t12x2x1p = GenericTBrick1(12,2)
#declare t14x2x1p = GenericTBrick1(14,2)
#declare t16x2x1p = GenericTBrick1(16,2)



#local Length = 5;
#local Widht  = 1;
#local Height = 1;

#declare t5x1x1c = union {
    difference {
        union {
            difference {
                union {
                    box {
                        <0, 0, LEGO_CORNER_SPACE>
                        <(Length-1) * LEGO_LENGTH, LEGO_HEIGHT, LEGO_LENGTH - LEGO_CORNER_SPACE>
                    }
                    box {
                        <0, LEGO_CORNER_SPACE, 0>
                        <(Length-1)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_LENGTH>
                    }
                    cylinder {
                        <0, LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
                        <(Length-1)*LEGO_LENGTH, LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
                        LEGO_CORNER_SPACE
                    }
                    cylinder {
                        <0, LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
                        <(Length-1)*LEGO_LENGTH, LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
                        LEGO_CORNER_SPACE
                    }
                    cylinder {
                        <0, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
                        <(Length-1)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_CORNER_SPACE>
                        LEGO_CORNER_SPACE
                    }
                    cylinder {
                        <0, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
                        <(Length-1)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE, LEGO_LENGTH-LEGO_CORNER_SPACE>
                        LEGO_CORNER_SPACE
                    }

                    translate x*LEGO_LENGTH/2
                }

                box { <-EXTRA, -EXTRA, LEGO_WALL_WIDTH>
                      <Length*LEGO_LENGTH, LEGO_HEIGHT - LEGO_CEILING_HEIGHT, LEGO_LENGTH-LEGO_WALL_WIDTH> }
                box { <-EXTRA, -EXTRA, -EXTRA> <LEGO_LENGTH + 0.75, 0.5, LEGO_LENGTH+EXTRA> }
                box { <Length*LEGO_LENGTH + EXTRA, -EXTRA, -EXTRA>
                      <(Length-1)*LEGO_LENGTH-0.75, 0.5, LEGO_LENGTH+EXTRA> }

            }

            box { <LEGO_LENGTH + 0.75, 0, LEGO_WALL_WIDTH - EXTRA>
                  <LEGO_LENGTH + 1.75, LEGO_HEIGHT - LEGO_CEILING_HEIGHT + EXTRA, LEGO_LENGTH-LEGO_WALL_WIDTH + EXTRA> }
            box { <(Length-1)*LEGO_LENGTH - 0.75, 0, LEGO_WALL_WIDTH - EXTRA>
                  <(Length-1)*LEGO_LENGTH - 1.75, LEGO_HEIGHT - LEGO_CEILING_HEIGHT + EXTRA, LEGO_LENGTH-LEGO_WALL_WIDTH + EXTRA> }

            box { <LEGO_LENGTH + 0.75, 0, LEGO_WALL_WIDTH - EXTRA>
                  <LEGO_LENGTH + 1.75, LEGO_HEIGHT - LEGO_CEILING_HEIGHT + EXTRA, LEGO_LENGTH-LEGO_WALL_WIDTH + EXTRA>
                  translate x*(2*LEGO_KNOB_RADIUS+1) }
            box { <(Length-1)*LEGO_LENGTH - 0.75, 0, LEGO_WALL_WIDTH - EXTRA>
                  <(Length-1)*LEGO_LENGTH - 1.75, LEGO_HEIGHT - LEGO_CEILING_HEIGHT + EXTRA, LEGO_LENGTH-LEGO_WALL_WIDTH + EXTRA>
                  translate -x*(2*LEGO_KNOB_RADIUS+1) }
            union {
                cylinder {
                    <0, 0, 0>
                    <0, LEGO_HEIGHT-LEGO_CEILING_HEIGHT+EXTRA, 0>
                    LEGO_LENGTH/2-LEGO_CORNER_SPACE - EXTRA
                }
                cylinder {
                    <0, LEGO_CORNER_SPACE, 0>
                    <0, LEGO_HEIGHT-LEGO_CEILING_HEIGHT+EXTRA, 0>
                    LEGO_LENGTH/2 - EXTRA
                }
                torus {
                    LEGO_LENGTH/2-LEGO_CORNER_SPACE-EXTRA
                    LEGO_CORNER_SPACE
                    translate y*LEGO_CORNER_SPACE
                }
                translate <2.5, 0, 0.5>*LEGO_LENGTH
            }

            #local a = 0;
            #while (a < 2)
                union {
                    cylinder { <0, 0, 0>
                        <0, LEGO_HEIGHT, 0>
                        LEGO_LENGTH/2 - LEGO_CORNER_SPACE
                    }
                    cylinder {
                        <0, LEGO_CORNER_SPACE, 0>
                        <0, LEGO_HEIGHT-LEGO_CORNER_SPACE, 0>
                        LEGO_LENGTH/2
                    }
                    torus {
                        LEGO_LENGTH/2-LEGO_CORNER_SPACE
                        LEGO_CORNER_SPACE
                        translate y * (LEGO_HEIGHT-LEGO_CORNER_SPACE)
                    }
                    torus {
                        LEGO_LENGTH/2-LEGO_CORNER_SPACE
                        LEGO_CORNER_SPACE
                        translate y * LEGO_CORNER_SPACE
                    }
                    bounded_by { box { <-1, 0, -1>*LEGO_LENGTH/2  <1,0,1>*LEGO_LENGTH/2+y*LEGO_HEIGHT } }

                    translate <LEGO_LENGTH*(0.5+a*(Length-1)), 0, LEGO_LENGTH/2>
                }
                #local a = a+1;
            #end

            object { TKNOB translate <1*LEGO_LENGTH, LEGO_HEIGHT, 0> }
            object { TKNOB translate <3*LEGO_LENGTH, LEGO_HEIGHT, 0> }

        }

        #local a = 0;
        #while (a < 2)
            union {
                cylinder { <0, -EXTRA, 0>
                           <0, 2*LEGO_HEIGHT, 0>
                           LEGO_KNOB_RADIUS }
                cylinder { <0, LEGO_HEIGHT-LEGO_CORNER_SPACE/2, 0>
                           <0, 2*LEGO_HEIGHT, 0>
                           LEGO_KNOB_RADIUS+LEGO_CORNER_SPACE/2 }

                intersection {
                    object { __IKranz translate <0, -LEGO_HEIGHT + 0.8, 0> }
                    cylinder { -y*EXTRA  y*LEGO_HEIGHT  LEGO_LENGTH/2 + EXTRA }
                    bounded_by { cylinder { -y*EXTRA  y*LEGO_HEIGHT   LEGO_LENGTH/2+EXTRA } }
                }

                bounded_by { box { <-LEGO_LENGTH/2, -EXTRA, -LEGO_LENGTH/2>
                                   <LEGO_LENGTH/2, LEGO_HEIGHT, LEGO_LENGTH/2>  } }

                translate <(a*(Length-1)+0.5), 0, 0.5> * LEGO_LENGTH
            }

            #local a = a+1;
        #end

        object { __IAxle rotate z*90  translate <2.5, 0, 0.5>*LEGO_LENGTH }
        object { __INV_ROUND_AXLE rotate z*90 translate <2.5, 0, 0.5>*LEGO_LENGTH+y*LEGO_HEIGHT }
        object { __INV_ROUND_AXLE rotate -z*90 translate <2.5, 0, 0.5>*LEGO_LENGTH }

    }
    #local a = 0;
    #while (a < 2)
        torus {
            LEGO_KNOB_RADIUS+LEGO_CORNER_SPACE/2
            LEGO_CORNER_SPACE/2
            translate <(a*(Length-1)+0.5)*LEGO_LENGTH, LEGO_HEIGHT-LEGO_CORNER_SPACE/2, LEGO_LENGTH/2>
        }
        #local a = a+1;
    #end

    bounded_by { box { <0, 0, 0> <Length,0,1>*LEGO_LENGTH+y*(LEGO_HEIGHT+LEGO_KNOB_HEIGHT) }}
}


#end
