/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef (__LEGO_WHEEL_SUSPENSION)
#else

    #declare __LEGO_WHEEL_SUSPENSION = 1;


#include "roundcylinder.inc"
#include "invroundcylinder.inc"
#include "roundbox.inc"
#include "invroundbox.inc"
#include "inv_round_edge.inc"
  
#declare ____temp = difference {

  union {
    #declare ____tempSin = sin(22.5*pi/180);
    #declare ____tempDX    = (1 - ____tempSin) * LEGO_CORNER_SPACE;
    #declare ____tempDelta = < - ____tempSin,0,1> * LEGO_CORNER_SPACE;
    
    
    object { roundbox ( 40-l/2     + ____tempDX, l/2-2.5, l-4.1) translate <0,  2.5, -l>                       }
    object { roundbox ( 40-l/2     + ____tempDX, l/2-2.5, l-4.1) translate <0,  2.5, -l>      scale <1, -1, 1> }
    object { roundbox ( 40-l/2+2.2 + ____tempDX, l,       l-6.3) translate <0, -l/2, -l+2.2>                   }
    
    
    object { roundbox (4, l/2-2.5, 2.7) translate (-x-z)*LEGO_CORNER_SPACE rotate -y*45  translate <40-l/2, 2.5, -l> + ____tempDelta }
    object { roundbox (5, l/2-2.5, 2.7+1.3) translate (-x-z)*LEGO_CORNER_SPACE rotate -y*45  translate <40-l/2, 2.5, -l> + ____tempDelta scale <1, -1, 1> }


    object { 
      roundbox (sqrt(2)*(l-2.45-2.2)-2.7 + 2 * ____tempDX + 0.4, l, 1.7) 
      translate <-0.4,0,1> + (-x-z)*LEGO_CORNER_SPACE 
      rotate -y*45  
      translate <40-l/2+2.2, -l/2, -l+2.2> + ____tempDelta 
    }
    object {
      roundbox (sqrt(2)*(l/2-2.2)+____tempDX+LEGO_CORNER_SPACE, l, 1.7)
      translate (-x-z)*LEGO_CORNER_SPACE 
      rotate -y*45  
      translate <40-l/2+2.2, -l/2, -l+2.2> + ____tempDelta 
    }

    #declare ___tempK = l - 4.1 - sqrt(2) * 2.7;
    #declare ___tempX = 40 - l/2 + ___tempK + 1.75;
    #declare ___tempL = 5.5*l - ___tempX;
    
    object { roundbox (___tempL+____tempDX, l, l/2-2.45) translate <___tempX-____tempDX, -l/2, -l/2> }
  



    object { roundcylinder(l-4.1, l/2) rotate -y*90 translate -z*l }
    object { roundcylinder(l-4.1, 3.2) rotate -y*90 translate (2*x-z)*l }
    object { roundcylinder(l-4.1, 3.2) rotate -y*90 translate (3*x-z)*l }
    object { roundcylinder(l-4.1, 3.2) rotate -y*90 translate (4*x-z)*l }
  }
  

  object { h_invroundcylinder(0.8, LEGO_TUBE_INLAY_RADIUS) rotate y*90 translate -z*4.1+x*0*l }
  object { h_invroundcylinder(0.8, LEGO_TUBE_INLAY_RADIUS) rotate y*90 translate -z*4.1+x*2*l }
  object { h_invroundcylinder(0.8, LEGO_TUBE_INLAY_RADIUS) rotate y*90 translate -z*4.1+x*3*l }
  object { h_invroundcylinder(0.8, LEGO_TUBE_INLAY_RADIUS) rotate y*90 translate -z*4.1+x*4*l }

  object { invroundcylinder (l-4.9, LEGO_KNOB_RADIUS) rotate -y*90 translate -z*l+x*0*l } 
  object { invroundcylinder (l-4.9, LEGO_KNOB_RADIUS) rotate -y*90 translate -z*l+x*2*l } 
  object { invroundcylinder (l-4.9, LEGO_KNOB_RADIUS) rotate -y*90 translate -z*l+x*3*l } 
  object { invroundcylinder (l-4.9, LEGO_KNOB_RADIUS) rotate -y*90 translate -z*l+x*4*l } 
  
  object { h_invroundbox(0.8, l, 6) rotate y*90 translate <-3+0*l, 0, -4.1> }
  object { h_invroundbox(0.8, l, 6) rotate y*90 translate <-3+2*l, 0, -4.1> }
  object { h_invroundbox(0.8, l, 6) rotate y*90 translate <-3+3*l, 0, -4.1> }
  object { h_invroundbox(0.8, l, 6) rotate y*90 translate <-3+4*l, 0, -4.1> }
}

#declare WheelSuspension = difference {
  union {
    object {____temp}
    object {____temp scale <1, 1, -1>}
    
    object { roundbox (1.2, l, 10)     translate <13.8-l/2, -l/2, -5> }
    object { roundbox (4.2, l-6.7, 10) translate <13.8-l/2, -l/2, -5> }
	
    object { roundcylinder(l, l/2)     rotate  z*90 translate -y*l/2+5.5*x*l }
    
    object { roundbox(6*l-40, l/2-2.5, l) translate <40-l/2, -l/2, -l/2> }
  }

  object { h_invroundbox(l/4, 6, 9.8) rotate -z*90 translate <-3+0*l, l/2, -4.9> }
  object { h_invroundbox(l/4, 6, 9.8) rotate -z*90 translate <-3+2*l, l/2, -4.9> }
  object { h_invroundbox(l/4, 6, 9.8) rotate -z*90 translate <-3+3*l, l/2, -4.9> }
  object { h_invroundbox(l/4, 6, 9.8) rotate -z*90 translate <-3+4*l, l/2, -4.9> }
  
  
  object { h_invroundcylinder(l/2, LEGO_TUBE_INLAY_RADIUS) rotate -z*90 translate <5.5, 0.5, 0>*l }
  sphere { <5.5*l, 0, 0>  LEGO_TUBE_INLAY_RADIUS }
  object { invroundcylinder(l, 1.3) rotate -y*90 translate <5.5*l, 0, -l/2> }  
 
  texture { LegoBlue }
}







  #local __temp = union {
    #local __h = 8.6*LEGO_LENGTH/2/(LEGO_LENGTH/2-1.5);
    difference {
      intersection {
	prism {
	  conic_sweep
	  linear_spline
	  0
	  1
	  13
	  <+0.7, +0.7> <+l/2, +0.7> <+l/2, -0.7>
	  <+0.7, -0.7> <+0.7, -l/2> <-0.7, -l/2>
	  <-0.7, -0.7> <-l/2, -0.7> <-l/2, +0.7>
	  <-0.7, +0.7> <-0.7, +l/2> <+0.7, +l/2>
	  <+0.7, +0.7>
	  translate -y
	  scale <1, -1, 1>
	}
	cone { <0, 0, 0> l/2 <0, 1, 0> 0 }
	scale <1, __h, 1>
      }

      #local __round_e = object { 
	#local __eps = atan2(0.7, LEGO_LENGTH/2)*180/pi;
	inv_roundedge(LEGO_LENGTH*2, 90+__eps) 
	rotate z*90
	rotate -y*__eps
	rotate x*atan2(LEGO_LENGTH/2,__h)*180/pi 
	translate -z*LEGO_LENGTH/2	
	rotate y*__eps
      }

      #local i=0;
      #while (i < 4)
	object { __round_e                rotate y*i*90 }
	object { __round_e scale <-1,1,1> rotate y*i*90 }
	#local i=i+1;
      #end
      translate y*(l/2-LEGO_CORNER_SPACE)
    }
    cylinder { <0, 0, 0> <0, 2*l, 0> 1.5 }
    sphere { <0, 2*l, 0> 2.85 }
  }

  
  #declare WheelBearing = difference {
    union {
      difference {
	union {
	  object {__temp }
	  object {__temp scale <1, -1, 1>}
	  
	  object { roundcylinder(LEGO_LENGTH, LEGO_LENGTH/2) rotate z*90 translate -y*LEGO_LENGTH/2}
	  object { roundcylinder(LEGO_LENGTH, LEGO_LENGTH/2) translate -x*LEGO_LENGTH/2 }
	  

	  #local ___t = LEGO_CORNER_SPACE*(2-sqrt(2));
	  object {
	    roundbox (sqrt(2)*3*h+(sqrt(2)-1)*l + 2*___t, 3.2, LEGO_LENGTH)
	    translate <-(sqrt(2)-1)*l-___t, -1.6, 0>
	    rotate -y*45  translate <l/2, 0, l/2> }
	    
	  object { roundbox(LEGO_LENGTH, 3.2, l/2-(l-l/sqrt(2))+l/sqrt(2)+___t) translate <-LEGO_LENGTH/2, -1.6, 0> }
	  object { roundbox(LEGO_LENGTH, 3.2, 2.5*LEGO_LENGTH-3*h+___t) translate <3*h-LEGO_LENGTH/2, -1.6, 3*h+LEGO_LENGTH/2-___t> }
	}
	object { invroundcylinder(LEGO_LENGTH-LEGO_WALL_WIDTH, LEGO_KNOB_RADIUS) translate -x*(LEGO_LENGTH/2-LEGO_WALL_WIDTH/2) }
	object { h_invroundcylinder(LEGO_WALL_WIDTH/2, LEGO_TUBE_INLAY_RADIUS) translate -x*LEGO_LENGTH/2 }	
	object { h_invroundcylinder(LEGO_WALL_WIDTH/2, LEGO_TUBE_INLAY_RADIUS) rotate y*180 translate x*LEGO_LENGTH/2 }	
	
	
	#local ___x = 4.8;
	#local ___s = l/2*sin(22.5*pi/180);
	#local ___m = l/2+___s;
	#local ___db = ___s + 1.6/sqrt(2);

	#local ___A_ = object { h_invroundbox(0.8,         ___x, LEGO_LENGTH*5) rotate -z*90  translate <3*h-___x/2,1.6, 3*h+___m> }
	#local ___A  = object { h_invroundbox(0.8+EXTRA,   ___x, LEGO_LENGTH*6) rotate -z*90  translate <3*h-___x/2,1.6, 0> }
	#local ___C  = object { h_invroundbox(0.8+EXTRA,   ___x+1.6/sqrt(2), LEGO_LENGTH*3) rotate -z*90  translate <-___x/2,1.6, l/2+1.6> }
	#local ___B  = object { h_invroundbox(0.8+2*EXTRA, ___x, LEGO_LENGTH*6) rotate -z*90  translate <-___x/2,1.6, -2*l> rotate y*45 translate z*___m}
	#local ___B_ = object { h_invroundbox(0.8, ___x+2*EXTRA, 3*h*sqrt(2)-___db ) rotate -z*90  translate <-___x/2-EXTRA,1.6, ___db>    rotate y*45 translate z*___m}
	
	#local __cut = union {
	  object { ___A_ }
	  object { ___B_ }
	  intersection {
	    object { ___A }
	    object { ___B }
	  }
	  intersection {
	    object { ___B }
	    object { ___C }
	  }
	}
	
	object { __cut }
	object { __cut scale <1,-1,1> }
	
      }
      object { roundcylinder(3.2, LEGO_LENGTH/2) rotate z*90 translate <3*h, -1.6, 3*l> }
    }
    object { __IAxle          rotate z*90 translate <3*h, 0,   3*l> }
    object { __INV_ROUND_AXLE rotate z*90 translate <3*h, 1.6, 3*l> } 
    object { __INV_ROUND_AXLE rotate z*90 translate <3*h, 1.6, 3*l> scale <1,-1,1>} 
  }


  
#end