
/*******************************************************************************

                      LEGO for POV-Ray 3.5
                     (C) Ernst Martin Witte

   This file is in no way related to the LEGO(tm) Group.
   It is provided for private non-commercial use only.

 *******************************************************************************/

#ifdef (__LEGO_X_BRICKS_INC)
#else

  #declare __LEGO_X_BRICKS_INC = 1;


  #include "invroundbox.inc"
  #include "roundbox.inc"
  #include "invroundcylinder.inc"
  #include "roundcylinder.inc"
  #include "inv_round_edge.inc"
  
  
  #declare d1x1x3p = difference {
    union {
      object { roundbox(LEGO_LENGTH, 3*LEGO_HEIGHT, 2*LEGO_HEIGHT) 
	translate z*(LEGO_LENGTH-2*LEGO_HEIGHT)
      }
      object { roundbox(LEGO_LENGTH, 3*LEGO_HEIGHT-LEGO_LENGTH, LEGO_LENGTH/2) }
      object { KNOB translate y*3*LEGO_HEIGHT }
      object { h_roundcylinder(LEGO_KNOB_HEIGHT, LEGO_KNOB_RADIUS)
	rotate -y*90
	translate <LEGO_LENGTH/2, 3*LEGO_HEIGHT-LEGO_LENGTH/2, LEGO_LENGTH-2*LEGO_HEIGHT-LEGO_KNOB_HEIGHT> }
    }
    object { 
      h_invroundbox(3*LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH-2*LEGO_WALL_WIDTH, 2*LEGO_HEIGHT-2*LEGO_WALL_WIDTH)
      rotate z*90
      translate <LEGO_LENGTH-LEGO_WALL_WIDTH, 0, LEGO_LENGTH-2*LEGO_HEIGHT+LEGO_WALL_WIDTH>
    }
    object {
      h_invroundbox(LEGO_WALL_WIDTH, LEGO_LENGTH-LEGO_CEILING_HEIGHT-LEGO_WALL_WIDTH, LEGO_LENGTH-2*LEGO_WALL_WIDTH)
      rotate y*90
      translate <LEGO_WALL_WIDTH, 3*LEGO_HEIGHT-LEGO_LENGTH+LEGO_WALL_WIDTH, LEGO_LENGTH>
    }
    object {
      invroundcylinder(LEGO_KNOB_HEIGHT+LEGO_WALL_WIDTH, LEGO_KNOB_INNER_RADIUS)
      rotate -y*90
      translate <LEGO_LENGTH/2, 3*LEGO_HEIGHT-LEGO_LENGTH/2, LEGO_LENGTH-2*LEGO_HEIGHT-LEGO_KNOB_HEIGHT>
    }
   
  }
  

  
  #declare e2x2x1p = union {
    difference {
      object { roundbox(LEGO_LENGTH*2, LEGO_HEIGHT, LEGO_LENGTH*2) }
      object { invroundbox(LEGO_HEIGHT, LEGO_LENGTH*2, LEGO_LENGTH*2) 
	rotate -z*90
	translate <LEGO_LENGTH, LEGO_HEIGHT, LEGO_LENGTH> }
      object { h_invroundbox(LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH-LEGO_WALL_WIDTH*2, LEGO_LENGTH*2-LEGO_WALL_WIDTH*2)
	rotate z*90
	translate <LEGO_LENGTH-LEGO_WALL_WIDTH+EXTRA, 0, LEGO_WALL_WIDTH+EXTRA> }
      object { h_invroundbox(LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH*2-LEGO_WALL_WIDTH*2, LEGO_LENGTH-LEGO_WALL_WIDTH*2)
	rotate z*90
	translate <LEGO_LENGTH*2-LEGO_WALL_WIDTH, -EXTRA, LEGO_WALL_WIDTH> }
      object { INV_INNER_KNOB translate <0, LEGO_HEIGHT, 0> }
      object { INV_INNER_KNOB translate <LEGO_LENGTH, LEGO_HEIGHT, 0> }
      object { INV_INNER_KNOB translate <0, LEGO_HEIGHT, LEGO_LENGTH> }
    }
    object { KNOB translate <0, LEGO_HEIGHT, 0> }
    object { KNOB translate <LEGO_LENGTH, LEGO_HEIGHT, 0> }
    object { KNOB translate <0, LEGO_HEIGHT, LEGO_LENGTH> }
    object { SCYLINDER1 translate x*LEGO_LENGTH }
    object { SCYLINDER1 rotate y*90 translate z*LEGO_LENGTH }
  }

  
  #local __l = LEGO_LENGTH/2+LEGO_WALL_WIDTH;
  #local __w = LEGO_LENGTH/5;
  #local __zng = union {
    object { roundbox(__l, LEGO_HEIGHT, __w) }
    object { roundcylinder(__w, LEGO_HEIGHT/2) rotate -y*90 translate y*LEGO_HEIGHT/2 }
  }
  
  #declare w2x1x1p3 = union {
    difference {
      union {
	object { roundbox(LEGO_LENGTH*2, LEGO_HEIGHT, LEGO_LENGTH) }
	object { roundcylinder(LEGO_LENGTH, LEGO_HEIGHT/2)
	  rotate -y*90 translate y*LEGO_HEIGHT/2 }
	object { TKNOB translate y*LEGO_HEIGHT }
	object { TKNOB translate <LEGO_LENGTH, LEGO_HEIGHT, 0> }
      }
      object { h_invroundbox(LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH*2-LEGO_WALL_WIDTH, LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	rotate z*90
	translate <LEGO_LENGTH*2-LEGO_WALL_WIDTH, 0, LEGO_WALL_WIDTH> }      
    }
    object { SCYLINDER1 translate x*LEGO_LENGTH }
    object { __zng translate <-LEGO_LENGTH/2, 0, 0> }
    object { __zng translate <-LEGO_LENGTH/2, 0, __w*2> }
    object { __zng translate <-LEGO_LENGTH/2, 0, __w*4> }
  }

  #declare w2x1x1p2 = union {
    difference {
      union {
	object { roundbox(LEGO_LENGTH*2, LEGO_HEIGHT, LEGO_LENGTH) }
	object { roundcylinder(LEGO_LENGTH, LEGO_HEIGHT/2)
	  rotate -y*90 translate y*LEGO_HEIGHT/2 }
	object { TKNOB translate y*LEGO_HEIGHT }
	object { TKNOB translate <LEGO_LENGTH, LEGO_HEIGHT, 0> }
      }
      object { h_invroundbox(LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH*2-2*LEGO_WALL_WIDTH, LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	rotate z*90
	translate <LEGO_LENGTH*2-LEGO_WALL_WIDTH, 0, LEGO_WALL_WIDTH> }
    }
    object { SCYLINDER1 translate x*LEGO_LENGTH }
    object { __zng translate <-LEGO_LENGTH/2, 0, __w*1> }
    object { __zng translate <-LEGO_LENGTH/2, 0, __w*3> }
  }

  #declare w2x1x1f2 = union {
    difference {
      union {
	object { roundbox(LEGO_LENGTH*2.5+LEGO_HEIGHT, LEGO_HEIGHT, LEGO_LENGTH) 
	  translate <-LEGO_LENGTH*0.5-LEGO_HEIGHT, 0, 0> }
	difference {
	  union {
	    object { __zng translate -y*LEGO_HEIGHT/2 rotate -z*90 translate <-LEGO_LENGTH/2, LEGO_HEIGHT*1.5, __w*1> }
	    object { __zng translate -y*LEGO_HEIGHT/2 rotate -z*90 translate <-LEGO_LENGTH/2, LEGO_HEIGHT*1.5, __w*3> }
	  }
	  box { <0,-LEGO_LENGTH,0> <-LEGO_LENGTH, LEGO_HEIGHT/2, LEGO_LENGTH> }
	}
      }
      object { h_invroundbox(LEGO_HEIGHT-LEGO_CEILING_HEIGHT, LEGO_LENGTH*3, LEGO_LENGTH-2*LEGO_WALL_WIDTH)
	rotate z*90
	translate <LEGO_LENGTH*2-LEGO_WALL_WIDTH, 0, LEGO_WALL_WIDTH> }
      object { h_invroundbox(LEGO_LENGTH, LEGO_HEIGHT-LEGO_CEILING_HEIGHT-EXTRA, LEGO_LENGTH-2*LEGO_WALL_WIDTH-2*EXTRA)
	translate <-LEGO_LENGTH/2 - LEGO_HEIGHT, 0, LEGO_WALL_WIDTH+EXTRA> }
    }
    object { SCYLINDER1 translate x*LEGO_LENGTH*0 }
    object { SCYLINDER1 translate x*LEGO_LENGTH*1 }
    difference {
      union {
	object { roundbox(1, LEGO_HEIGHT, LEGO_LENGTH) translate x*(LEGO_LENGTH*0-0.5) }
	object { roundbox(1, LEGO_HEIGHT, LEGO_LENGTH) translate x*(LEGO_LENGTH*1-0.5) }
      }
      cylinder { <LEGO_LENGTH*0, -1, LEGO_LENGTH/2> <LEGO_LENGTH*0, LEGO_HEIGHT, LEGO_LENGTH/2> (LEGO_SCYLINDER_RADIUS+LEGO_SCYLINDER_INNER_RADIUS)/2 }
      cylinder { <LEGO_LENGTH*1, -1, LEGO_LENGTH/2> <LEGO_LENGTH*1, LEGO_HEIGHT, LEGO_LENGTH/2> (LEGO_SCYLINDER_RADIUS+LEGO_SCYLINDER_INNER_RADIUS)/2 }
    }
  }
  
#end

